; 
; Modified 2005-01-05 U.Neudecker
    .486                        ; force 32 bit code
    .model flat, stdcall        ; memory model & calling convention
    option casemap :none        ; case sensitive
; 
; 



.code

; 

align 16

StrComp proc uses ebx ecx edx edi, str1:DWORD, str2:DWORD, strlen:dword

  ; --------------------------------------
  ; scan length terminated string for match
  ; Returning 0   : Match
  ;           1   ; str1 > str2
  ;          -1   ; str1 < str2
  ; --------------------------------------
    mov ecx, str1
    mov edx, str2
    mov edi, strlen
        
    shr edi, 2
    .while edi > 0
        mov eax, [ecx]
        mov ebx, [edx]
        cmp eax, ebx
        jne no_match1
        add edx, 4
        add ecx, 4        
        dec edi
    .endw
    
    mov edi, strlen
    and edi, 3
    .while edi > 0
        mov al, [ecx]
        mov bl, [edx]
        cmp al, bl
        jne no_match2
        add edx, 1
        add ecx, 1        
        dec edi
    .endw
    
    xor eax, eax
    ret

  no_match1:
    bswap eax
    bswap ebx
    .if eax < ebx
      mov eax, dword ptr[-1]
    .else
      mov eax, 1
    .endif
    ret

  no_match2:
    .if al < bl
      mov eax, dword ptr[-1]
    .else
      mov eax, 1
    .endif
    ret
StrComp endp

; 

align 16

StrCompX proc uses ebx ecx edx edi esi, str1:DWORD, str2:DWORD, strlen:dword, pCharSet:dword
  ; --------------------------------------
  ; scan length terminated string for match
  ; Returning 0   : Match
  ;           1   ; str1 > str2
  ;          -1   ; str1 < str2
  ; --------------------------------------

LOCAL HREG:DWORD
LOCAL I:DWORD

    mov eax, strlen
    mov ecx, str1
    shr eax, 2
    mov edi, str2
    mov esi, pCharSet
    mov I,   eax
    xor ebx, ebx
    xor eax, eax
    
    .while I > 0
        mov al, byte ptr[ecx + 0]
        mov bl, byte ptr[ecx + 1]
        mov dl, byte ptr[esi + eax]
        mov dh, byte ptr[esi + ebx]
        bswap edx
        mov al, byte ptr[ecx + 2]
        mov bl, byte ptr[ecx + 3]
        mov dh, byte ptr[esi + eax]
        mov dl, byte ptr[esi + ebx]

        mov HREG, edx               ; save 4 Bytes , converted and swapped

        mov al, byte ptr[edi + 0]
        mov bl, byte ptr[edi + 1]
        mov dl, byte ptr[esi + eax]
        mov dh, byte ptr[esi + ebx]
        bswap edx
        mov al, byte ptr[edi + 2]
        mov bl, byte ptr[edi + 3]
        mov dh, byte ptr[esi + eax]
        mov dl, byte ptr[esi + ebx]

        cmp HREG, edx
        jne no_match1
        add edi, 4
        add ecx, 4        
        sub I,   1
    .endw

    mov eax, strlen
    mov I,   eax
    and I,   3

    .while I > 0
        mov al, byte ptr[ecx]
        mov bl, byte ptr[edi]
        mov al, byte ptr[esi + eax]
        mov bl, byte ptr[esi + ebx]
        cmp al, bl
        jne no_match2
        add edi, 1
        add ecx, 1        
        sub I,   1
    .endw
    
    xor eax, eax
    ret

  no_match1:
    .if HREG < edx
      mov eax, dword ptr[-1]
    .else
      mov eax, 1
    .endif
    ret

  no_match2:
    .if al < bl
      mov eax, dword ptr[-1]
    .else
      mov eax, 1
    .endif
    ret

StrCompX endp


end
